///////////////////////////////////////////////////////////////////////////////
//	
//								Nano OS	Version	1.0
//						Copyright 2009 xxxxxxx, xxxxxxx
//	File:	C6713_Nano_Test.c
//	Author:	Balasubramanya bhat (bbhat@ncsu.edu)
//	Description: Nano OS Test file
//	
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include "SOURCES\NanoOS.h"
#include "SOURCES\Nano_Sem.h"
//#include "Nano_Malloc.h"

#define LED_on(x)        *(int *)0x90080000 |= 0x01 << x
#define LED_off(x)       *(int *)0x90080000 &= ~(0x01 << x)
#define LED_toggle(x)    *(int *)0x90080000 ^= (0x01 << x)

UINT32 stack1 [0x400];
UINT32 stack2 [0x400];
UINT32 stack3 [0x400];

int x = 0;
int y = 1000;
int z = 10000;
//int a = 10, b;
int a = 0;
int b = 1;
int c = 2;
int d = 3;


OS_PeriodicTask task1, task2, task3;
OS_Sem sem1;
OS_Sem sem2;

void task_fn1(int * ptr)
{
	OS_SemWait(&sem1);
	LED_toggle(*ptr);
}

void task_fn2(int * ptr)
{
	OS_SemWait(&sem2);
	LED_toggle(*ptr);
	OS_SemPost(&sem1);
}

void task_fn3(int * ptr)
{
	LED_toggle(*ptr);
	OS_SemPost(&sem2);
}

/*
void task_fn1(int * ptr)
{
	OS_PeriodicTask * task = (OS_PeriodicTask *) g_current_task;
	UINT32 dm = task->TBE_count;

	LED_toggle(*ptr);

}
*/
void main(int argc, char *argv[])
{
	OS_Init();
	OS_SemInit(&sem1, 0, 0);
	OS_SemInit(&sem2, 0, 0);
	
	#if 0
	OS_CreatePeriodicTask(5000, 5000, 1000, 0, stack1, sizeof(stack1), &task1, task_fn1, &x);
	OS_CreatePeriodicTask(5000, 5000, 1000, 100, stack2, sizeof(stack2), &task2, task_fn2, &y);
	OS_CreatePeriodicTask(5000, 5000, 1000, 200, stack3, sizeof(stack3), &task3, task_fn3, &z);
	#endif

	OS_CreatePeriodicTask(500000, 5000, 2000, 0, stack1, sizeof(stack1), &task1, task_fn1, &a);
	OS_CreatePeriodicTask(500000, 5000, 2000, 100, stack2, sizeof(stack2), &task2, task_fn2, &b);
	OS_CreatePeriodicTask(500000, 5000, 2000, 200, stack3, sizeof(stack3), &task3, task_fn3, &c);
	
	OS_Start();

	return;
}
