///////////////////////////////////////////////////////////////////////////////
//	
//								Nano OS	Version	1.0
//						Copyright 2009 xxxxxxx, xxxxxxx
//	File:	C6713_OS_Init.asm
//	Author:	Balasubramanya bhat (bbhat@ncsu.edu)
//	Description: OS Initialization routines
//	
///////////////////////////////////////////////////////////////////////////////

#include "NanoOS.h"
#include "Nano_Queue.h"

extern void C6713_SystemInit();
extern Nano_Queue g_ready_q;
extern Nano_Queue g_wait_q;
extern Nano_Queue g_ap_wait_q;

extern cregister volatile unsigned int CSR ;
extern cregister volatile unsigned int IER ;


///////////////////////////////////////////////////////////////////////////////
// Initialization function for the Nano OS
///////////////////////////////////////////////////////////////////////////////
void OS_Init(int argc, char *argv[])
{
	// Call system initializatoin routine
	C6713_SystemInit();

	// Start the scheduling timer
	Nano_InitTimer();

	// Initialize the global queue for timer waiting
	Nano_QueueInit(&g_ready_q); 
	Nano_QueueInit(&g_wait_q);
	Nano_QueueInit(&g_ap_wait_q);
}


///////////////////////////////////////////////////////////////////////////////
// Initialization of Interrupts processing
///////////////////////////////////////////////////////////////////////////////
void Nano_InitInterrupts()
{
	IER |= 0x02;
	CSR |= 0x03;
}
