#include "NanoOS.h"

#define HEAP_SIZE (4*1024)

UINT32 total_size_allocated = 0;
#pragma DATA_SECTION (heap_data, ".heap");
UINT32 heap_data[HEAP_SIZE];

void* OS_Malloc(UINT32 size_in_bytes)
{
  if(total_size_allocated + size_in_bytes <= HEAP_SIZE)
  {
    UINT32* ret_ptr = heap_data+total_size_allocated;
    total_size_allocated += size_in_bytes;
    return (ret_ptr);
  }
  return NULL;
}

