///////////////////////////////////////////////////////////////////////////////
//	
//								Nano OS	Version	1.0
//						Copyright 2009 xxxxxxx, xxxxxxx
//	File:	Nano_Sem.h
//	Author: Sandeep Budanur (sbudanu@ncsu.edu)
//	Description: Header file for the NanoOS Semaphore APIs
//	
///////////////////////////////////////////////////////////////////////////////

#ifndef _NANO_SEM_H
#define _NANO_SEM_H

#include "NanoOS.h"
#include "Nano_Queue.h"

typedef struct OS_Sem
{
  INT32 count;
  Nano_Queue queue;    
}OS_Sem;

OS_Error OS_SemInit(OS_Sem *sem, INT16 pshared, UINT32 value);
OS_Error OS_SemWait(OS_Sem *sem);
OS_Error OS_SemPost(OS_Sem *sem);
OS_Error OS_SemDestroy(OS_Sem *sem);
OS_Error OS_SemGetvalue(OS_Sem *sem, INT32 *val);
#endif //_NANO_SEM_H
